#include "Demo.inc"

.org demo_exec_ram


    jp intro_start
    call page6
    
    
    ld a,0
    call pause
    call pause
    call pause
    ret

intro_start:
    call enable_planes
    call white_screen
    ld de,$f700
    ld hl,logo
    call DispRLE

    ld a,20
    call fade_in    
    
    ld a,50
    call pause

    call stop_scroll
    ld hl,intro_music
    call play_music
    
    call disable_planes
    ret
    
    
page1:
    call stop_scroll
    call clear_buffer
    ld hl,page1_t
    call display_text
    call start_scroll
    ret
    
page1_t:
    .db 0,6
    .text "Demo by:"
    .db 2,7
    .text "Hauberk"
    .db 3,3
    .db "(Leif ",cap,"strand)",0
    
    .db 5,5
    .text "Kallekanin"
    .db 6,3
    .db "(Kaj V",char,char,'n',char,"nen)",0
    
    .db $ff
    
    
page2:
    call clear_buffer
    ld hl,page2_t
    call display_text
    call start_scroll
    ret
    
page2_t:
    .db 1,4
    .text "Programming:"
    .db 2,6
    .text "Hauberk"
    
    .db 5,6
    .text "Artwork:"
    .db 6,5
    .text "Kallekanin"
    
    .db $ff
    
page3:
    call clear_buffer
    ld hl,page3_t
    call display_text
    call start_scroll
    ret
    
page3_t:
    .db 1,6
    .text "Effects:"
    .db 2,6
    .text "Hauberk"
    
    .db 5,7
    .text "Music:"
    .db 6,5
    .text "Kallekanin"
    .db $ff



page4:
    call clear_buffer
    ld hl,page4_t
    call display_text
    call start_scroll
    ret

page4_t:
    .db 0,5
    .text "Thanks to:"
    .db 2,1
    .text "Texas Instruments"
    .db 3,3
    .text "Jeremy Goetsch"
    .db 4,3
    .text "David Phillips"
    .db 5,8
    .text "Clem"
    .db 6,5
    .text "Dux Gregis"
    .db 7,4
    .text "Rusty Wagner"
    
    .db $ff
    
    
page5:
    call clear_buffer
    ld hl,page5_t
    call display_text
    call start_scroll
    ret
    
page5_t:
    .db 0,3
    .text "More thanks..."

    .db 1,4
    .text "Andreas Ess"    
    .db 2,2
    .text "Matthew Shepcar"
    .db 3,4
    .text "Jimi Malcolm"
    .db 4,5
    .text "Tunin crew"
    .db 5,8
    .text "wooz"
    .db 6,7
    .text "Tanja"
    .db 7,8
    .text "Mia"
    
    .db $ff
    
page6:
    call clear_buffer
    ld hl,page6_t
    call display_text
    call start_scroll
    ret
    
    
page6_t:
    .db 2,0
;          123456789012345678901     
    .text "And thanks to all the"
    
    .db 3,0
    .text "sceners and those who"
    .db 4,1
    .text "votes on our demo!"
    
 
    .db $ff

intro_music:
    .db 25,3,10
    .db 25,4,10
    .db 25,5,10
    .db 25,6,10
    
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    
    .db $ff
    .dw start_scroll    
    
    .db 25,3,10
    .db 25,4,10
    .db 25,5,10
    .db 25,6,10
    
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    
    .db 25,3,10
    .db 25,4,10
    .db 25,5,10
    .db 25,6,10
   
    
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    .db 25,1,3
    
    .db $ff
    .dw page1    
    
    .db 25,8,10
    .db 25,7,10
    .db 25,6,10
    .db 25,5,10
    
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    
    .db 25,3,10
    .db 25,4,10
    .db 25,5,10
    .db 25,6,10
    
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    
    .db 25,3,10
    .db 25,4,10
    .db 25,5,10
    .db 25,6,3
    
    .db $ff
    .dw page2
    
    
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    
    .db 25,3,10
    .db 25,4,10
    .db 25,5,10
    .db 25,6,10
   
    
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    
    .db 25,8,10
    .db 25,7,10
    .db 25,6,10
    .db 25,5,10
    
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    .db 25,1,3
    
    .db $ff
    .dw page3
    
    
    .db 9,3,5
    .db 9,3,5
    .db 9,4,5
    .db 9,4,5
    .db 25,5,10
    .db 25,6,10    
    
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    
    .db 9,3,5
    .db 9,3,5
    .db 9,4,5
    .db 9,4,5
    .db 25,5,10
    .db 25,6,10    
    
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    
    .db 9,3,5
    .db 9,3,5
    .db 9,4,5
    .db 9,4,5
    .db 25,5,10
    .db 25,6,3
    
    .db $ff
    .dw page4
    
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    
    .db 9,8,5
    .db 9,8,5
    .db 9,7,5
    .db 9,7,5
    .db 25,6,10
    .db 25,5,10    
    
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    
    .db 25,3,10
    .db 25,4,10
    .db 25,5,10
    .db 25,6,10
    
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    .db 25,1,3
    
    .db $ff
    .dw page5
        
    .db 25,3,10
    .db 25,4,10
    .db 25,5,10
    .db 25,6,10
    
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    
    .db 25,3,10
    .db 25,4,10
    .db 25,5,10
    .db 25,6,10
    
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    
    .db 25,8,10
    .db 25,7,10
    .db 25,6,10
    .db 25,5,3
    
    .db $ff
    .dw page6
    
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    
    .db 25,3,10
    .db 25,4,10
    .db 25,5,10
    .db 25,6,10
    
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    
    .db 25,3,10
    .db 25,4,10
    .db 25,5,10
    .db 25,6,10
    
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    
    .db $ff
    .dw scroll_out
    
    .db 25,3,10
    .db 25,4,10
    .db 25,5,10
    .db 25,6,10
    
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    
    .db 25,8,10
    .db 25,7,10
    .db 25,6,10
    .db 25,5,10
    
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10
    .db 25,1,10     
    
    .db 0

 
logo:
; compressed picture made with PIC2RLE
; PIC2RLE by David Phillips <david@acz.org>


 .db $91,$00,$10,$0f,$f0,$91,$00,$0e,$1f,$ff,$80,$91
 .db $00,$0d,$1f,$ff,$c0,$91,$00,$0d,$3f,$ff,$e0,$91
 .db $00,$0d,$3e,$3f,$e0,$60,$91,$00,$0c,$1f,$01,$e0
 .db $f0,$00,$18,$91,$00,$0a,$1f,$03,$e0,$f8,$00,$3c
 .db $91,$00,$0a,$0f,$0f,$e0,$f8,$00,$3c,$91,$00,$0a
 .db $0f,$ff,$c0,$78,$00,$3c,$91,$00,$0a,$0f,$ff,$80
 .db $78,$00,$3c,$91,$00,$0a,$0f,$fe,$00,$78,$00,$3c
 .db $91,$00,$04,$20,$91,$00,$05,$07,$f8,$00,$78,$00
 .db $3c,$91,$00,$04,$20,$91,$00,$05,$07,$80,$00,$78
 .db $00,$3c,$91,$00,$04,$fc,$91,$00,$05,$07,$80,$00
 .db $78,$00,$3c,$91,$00,$04,$23,$91,$00,$05,$07,$83
 .db $e0,$78,$00,$3c,$3c,$91,$00,$03,$21,$b0,$91,$00
 .db $04,$07,$87,$f0,$7f,$f0,$3f,$ff,$00,$7c,$00,$21
 .db $f8,$91,$00,$04,$07,$8f,$f8,$7f,$f8,$3f,$ff,$81
 .db $fe,$00,$21,$48,$91,$00,$04,$07,$9f,$f8,$7f,$f8
 .db $3f,$ff,$83,$ff,$00,$21,$48,$91,$00,$04,$07,$9f
 .db $f8,$ff,$f0,$3f,$f7,$07,$ff,$80,$00,$08,$91,$00
 .db $04,$07,$9f,$f8,$fc,$00,$3f,$80,$07,$df,$c0,$91
 .db $00,$06,$07,$9f,$f0,$fe,$00,$3f,$c0,$07,$9f,$c0
 .db $91,$00,$06,$07,$9f,$00,$ff,$00,$3f,$e0,$07,$bf
 .db $e0,$91,$00,$06,$0f,$8f,$00,$ff,$80,$3f,$e0,$07
 .db $ff,$f0,$91,$00,$06,$0f,$8f,$c0,$ff,$e0,$3d,$f8
 .db $07,$fd,$f0,$91,$00,$06,$0f,$0f,$f8,$f7,$f0,$3d
 .db $fc,$07,$fc,$fc,$91,$00,$06,$0f,$07,$fc,$f3,$f8
 .db $3c,$fe,$03,$f0,$fe,$91,$00,$06,$0f,$01,$fc,$60
 .db $fc,$3c,$3e,$00,$00,$7e,$91,$00,$06,$0f,$00,$f8
 .db $00,$7c,$18,$1e,$00,$00,$1c,$91,$00,$06,$0f,$91
 .db $00,$03,$38,$00,$0c,$91,$00,$09,$06,$91,$00,$50
 .db $0e,$91,$00,$0f,$30,$91,$00,$0f,$20,$91,$00,$06
 .db $20,$91,$00,$08,$20,$91,$00,$06,$20,$91,$00,$08
 .db $20,$00,$0c,$91,$00,$04,$20,$91,$00,$08,$20,$00
 .db $04,$91,$00,$04,$20,$00,$00,$04,$91,$00,$05,$10
 .db $03,$00,$02,$91,$00,$03,$20,$00,$00,$04,$91,$00
 .db $05,$08,$04,$80,$05,$80,$00,$00,$20,$00,$00,$04
 .db $91,$00,$05,$08,$08,$c4,$08,$03,$46,$00,$20,$00
 .db $00,$04,$91,$00,$05,$04,$08,$c2,$68,$06,$42,$00
 .db $20,$00,$01,$04,$91,$00,$05,$03,$08,$b2,$18,$08
 .db $42,$00,$20,$00,$00,$04,$91,$00,$06,$88,$92,$18
 .db $10,$62,$f8,$20,$00,$00,$04,$91,$00,$04,$02,$00
 .db $48,$92,$18,$10,$63,$0c,$20,$00,$20,$1f,$c0,$00
 .db $80,$00,$02,$00,$44,$96,$18,$10,$a3,$04,$20,$00
 .db $70,$04,$91,$00,$04,$07,$00,$43,$08,$08,$11,$13
 .db $0c,$27,$c1,$88,$04,$91,$00,$03,$38,$00,$ff,$c0
 .db $00,$00,$0e,$1b,$04,$38,$21,$09,$84,$00,$80,$00
 .db $f8,$91,$00,$06,$0b,$04,$30,$22,$08,$84,$06,$c0
 .db $83,$08,$91,$00,$06,$01,$04,$20,$24,$08,$84,$08
 .db $c0,$c2,$18,$91,$00,$07,$04,$20,$24,$18,$84,$08
 .db $c0,$42,$18,$91,$00,$08,$20,$16,$20,$84,$0d,$a0
 .db $42,$28,$91,$00,$08,$20,$03,$c0,$84,$07,$1c,$42
 .db $44,$91,$00,$0b,$06,$00,$00,$43,$c4,$91,$00,$0b
 .db $02,$00,$00,$40,$06,$91,$00,$0e,$40,$91,$00,$0e
 .db $30,$40,$91,$00,$0e,$18,$40,$91,$00,$0e,$07,$c0
 .db $91,$00,$21

; 1024 bytes compressed to 627 -- 61% of original.
 
 
.end
